;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;      MOVID  MOPPEL-Video-Monitor  V 7.6.1           ;
;;                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;   Stand:   Mo,20.04.87;12:25:33h
;
; Ueberarbeitet und Anpassung auf 8085Simulator-ID
;				https://www.oshonsoft.com/
;				notepad++ Tab = 6
;
; 30.07.2023 	Quellen von HMS (werner.roemer@t-online.de)
;			externe Bereiche ans Ende gestellt
;			(Vergleich EPROM mit Quelle ist OK)
;
	org    1000h
;
;
stepff 	equ	1ah            ;Portadressen
vidreg 	equ	28h
vidat  	equ	29h
vidctl 	equ	2ah
fdctrl 	equ	40h
belpor 	equ	0b9h
keypor 	equ	0bch
serctl 	equ	0e9h
serdat 	equ	0f9h
;
;
timprl 	equ	07h            ;Monitor-Unterprogramme
dely1  	equ	0bh
co     	equ	49h
lo     	equ	4fh
csinit 	equ	55h
loinit 	equ	58h
time   	equ	61h
v24adr 	equ	64h			;Adr!
writur 	equ	79h
readur 	equ	7ch
restor 	equ	82h
fill   	equ	85h 			;KILL-3
copy   	equ	88h
casot  	equ	8bh
casin  	equ	8eh
exchan 	equ	91h
;
;
menue0m  	equ	0d82h          ;externe Festadressen
asctab 	equ	0f10h
rombnk 	equ	2000h
prmtst 	equ	2006h
basic 	equ	4000h
ass    	equ	6000h
dis    	equ	6c00h
edi    	equ	7000h
sort   	equ	7af0h
prmv5  	equ	7c90h
user  	equ	0f000h
;
rambeg 	equ	2800h          ;RAM-Bereich
monram 	equ	2b00h
fdcram 	equ	2e9ch
vidram 	equ	3000h

;
;
movid:	jmp  mokalt    ;Sprungverteiler (Festadressen)
		jmp  warm0
		jmp  covid
		jmp  consin
		jmp  cstats
		jmp  break
		jmp  parin
		jmp  hxtest
		jmp  revise
		jmp  rdezu
		jmp  v24out
		jmp  string
		jmp  v24in
		jmp  error
		jmp  undrln
		jmp  clrvid
		jmp  clrlin
		jmp  crspos
		jmp  crson
		jmp  crsoff
		jmp  adrot
		jmp  bytot
		jmp  bytbin
		jmp  regsot
		jmp  ok
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Hauptprogramm
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
mokalt:	call init
kalt0: 	lxi  sp,stack
		lxi  h,menue0   ;Monitor-Grundmenue
		call string
		xra  a
		sta  levflg
warm0: 	lxi  h,promp0
		call string
		lxi  b,warm0
		lxi  d,kalt0
		lxi  h,jmptb0
		jmp  inquik
;
jmptb0:	db "M"
		dw memy
		db "O"
		dw outwrd
		db "P"
		dw periph
		db "S"
		dw start
		db 0h
;
;;;
;
memy:  	lxi  h,menue1   ;Speicher-Menue
		call strinf
warm1: 	lxi  h,promp1
		call string
		lxi  b,warm1
		lxi  d,memy
		lxi  h,jmptb1
		jmp  inpara
;
jmptb1:	db "C"
		dw move        ;i.e.COPY
		db "F"
		dw fillup
		db "K"
		dw kill
		db "L"
		dw list
		db "M"
		dw memory
		db "R"
		dw revise
		db "T"
		dw text
		db "X"
		dw change
		db 0h
;
;;;
;
outwrd:	lxi  h,menue2   ;Verzweigungs-Menue
		call strinf
warm2: 	lxi  h,promp2
		call string
		lxi  b,warm2
		lxi  d,outwrd
		lxi  h,jmptb2
		jmp  inquik
;
jmptb2:	db "A"
		dw ass
		db "B"
		dw basic
		db "D"
		dw dis
		db "E"
		dw edi
		db "F"
		dw fdc
		db "P"
		dw prom
		db "X"
		dw extens
		db 0h
;
;;;
;
periph:	lxi  h,menue3   ;Peripherie-Menue
		call strinf
warm3: 	lxi  h,promp3
		call string
		lxi  b,warm3
		lxi  d,periph
		lxi  h,jmptb3
		jmp  inpara
;
jmptb3:	db "I"
		dw casinp
		db "O"
		dw casotp
		db "T"
		dw termnl
		db "U"
		dw uhrint
		db "V"
		dw v24inp
		db "W"
		dw v24otp
		db 0h
;
;;;
;
start: 	lxi  h,menue4   ;Ausfuehrungs-Menue
		call strinf
warm4: 	lxi  h,promp4
		call string
		lxi  b,warm4
		lxi  d,start
		lxi  h,jmptb4
		jmp  inpara
;
jmptb4:	db "G"
		dw go
		db "S"
		dw sinstp
		db "U"
		dw user
		db "Y"
		dw byte
		db "Z"
		dw breakp
		db 0h
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Speicherverwaltung
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
move:  	call copy      ;i.e.COPY
movcte:	jnz  ok
		push psw
		call error
		pop  psw
		cpi  19h
		rnz
		jmp  revise    ;Einschreiben fehlgeschlagen
;
;
fillup:	call fill
		jmp  movcte
;
;
kill:  	lxi  h,movcte
		push h
		lhld 86h       ;FILL-Adr.
		dcx  h
		dcx  h
		dcx  h
		pchl           ;CALL
;
;
list:  	lhld srcbeg
		mov  a,l
		ani  0f0h
		mov  l,a
		shld hexadr
		lhld srcend
		inx  h
		shld hexend
		jmp  hxlist
;
;
text:  	lhld srcend
		mov  a,h       ;00:0Dh+0Ah; xx:nur 0Dh
		mov  b,l
		lhld srcbeg
		dcx  h
		ora  a         ;H-Nullabfrage
		mvi  a,0dh     ;Anfangs-CRLF
		mvi  c,0ah
		jz   stri      ;zus{tzliches LF bei 0Dh
		mvi  c,0dh     ;sonst 0Dh/0Dh
		jmp  stri
;
;
change:	call exchan
		jmp  movcte
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Peripherie-Ansprache
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
prom:  	adi  40h
extens:	adi  80h
fdc:   	out  fdctrl
		cpi  0c0h
		jnz  rombnk    ;kein Prommer
		lda  prmtst
		cpi  "p"
		jz   rombnk    ;V.6
		jmp  prmv5     ;V.5
;
;
casinp:	call csinit
		call casin
		jz   error
		jmp  ok
;
;
casotp:	call csinit
		call casot
		jmp  ok
;
;
v24inp:	call v24prp
v24ilp:	call v24in
		mov  m,a
		call v24cmp
		jmp  v24ilp
;
;
v24otp:	call v24prp
v24olp:	mov  c,m
		call v24out
		call v24cmp
		jmp  v24olp
;
v24prp:	call v24ini
		lhld srcend
		inx  h
		xchg
		lhld srcbeg
		ret
;
v24cmp:	inx  h
		mov  a,e
		cmp  l
		rnz
		mov  a,d
		cmp  h
		rnz
		pop  psw
		jmp  ok
;
serini:	lxi  d,16h     ;H&L:Baudrate; A:Mode
		jmp  inicte
dfueini:	lxi  d,0bh
		jmp  inicte
v24ini:	lxi  d,0h
inicte:	push h
		lhld v24adr    ;Bezugadresse
		dad  d
		xchg           ;D&E:Startadresse
		pop  h
		lxi  b,iniret
		push b
		push d
iniret:	ret            ;1.)CALL; 2.)Return from Subr.
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Programmausfuehrung
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
go:    	call srcnul
		jmp  restor
;
;
byte: 	call srcnul
		mvi  a,40h
		out  stepff
		pchl
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Parameter-Eingabe
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
srcnul:	lhld srcbeg
		mov  a,l
		ora  h
		jnz  srcte
		lxi  h,rambeg
srcte: 	shld srcbeg
		shld adres
		ret
;
;
inquik:	xra  a         ;Schnellstart
		jmp  input
inpara:	mvi  a,"p"     ;Params einlesen
input: 	sta  inpflg
		dcx  h
		dcx  h
		shld hlbuf     ;H&L:Tab-Pointer
		push d
		push b
		call crson
		pop  d
		lhld update
		shld updbuf
inplop:	call consin
		cpi  9h
		jz   kalt0     ;TAB: sofort zum Grundmenue
		cpi  03h
		jz   inpend
		cpi  1bh
		jz   inpend
		mov  c,a
		call co
		lda  inpflg
		ora  a         ;Quick?
		jz   proces    ;ja
		mov  a,c
		cpi  0dh       ;Ret?
		jnz  inplop    ;nein
		push d
		lhld update
		lxi  d,13h
		dad  d         ;H&L hinter Params
		mvi  c,10h
		call parin
		pop  d
		jz   error
proces:	lhld updbuf
		mov  a,m
		push d
		ani  5fh
		mov  b,a
		xra  a
		sta  levflg
		lhld hlbuf
prolop:	inx  h
		inx  h
		mov  a,m
		inx  h
		ora  a
		jz   error
		cmp  b
		jnz  prolop
		mov  e,m
		inx  h
		mov  d,m
		xchg
		call crsoff
preles:	call cstats
		jnz  preles
		pchl
inpend:	lxi  h,levflg
		mov  a,m
		ora  a
		rz
		xra  a
		mov  m,a
		jmp  warm0
;
;
parin: 	lxi  d,srcbeg
		mvi  b,8h
parclr:	xra  a
		stax d
		inx  d
		dcr  b
		jnz  parclr
;
		mov  a,m       ;Zeichen vom Bildschirm holen
		cpi  20h       ;Blank?
		jz   inloop    ;Blank=o.k, d.h. JMP
		xra  a         ;FLAGs setzen
		mvi  a,3h      ;Par.feld zu lang
		ret            ;Fehler: Z=1
;
inloop:	lxi  d,0h      ;Displacement
		xchg
		shld dowo1     ;Hilfs-Buffer l|schen
		shld dowo2
		xchg
;
inlop: 	dcx  h
		dcr  c
		jp   inlop2
		xra  a         ;Input fehlt
		ret            ;Fehler: Z=1
;
inlop2:	mov  a,m
		cpi  20h       ;Blank?
		jz   inlop     ;ja:JMP (nachruecken)
		mov  b,a       ;Zeichen retten
;
		xra  a         ;REG A l|schen
		cmp  c         ;Param.-Anfang erreicht?
		mov  a,b
		jnz  incte     ;nein: JMP
		call assemb    ;Digits zusammensetzen
		inr  c         ;FLAGs l|schen
parend:	ret
;
incte: 	cpi  2ch       ;Komma?
		jz   inct      ;ja: JMP
		cpi  2eh       ;Punkt?
		jz   inct      ;ja: JMP
		call hxtst     ;Input ueberpruefen
		rz             ;Fehler: Z=1
		jmp  inlop     ;sonst weiter
;
inct:  	call assemb    ;Digits zusammensetzen
		jmp  inloop
;
assemb:	push psw
		push h
		push d
		lxi  h,dowo1   ;Digits zu Doppelwort
		mov  e,m       ;zusammensetzen
		inx  h
		mov  a,m
		rlc            ;oberes Nibble im
		rlc            ;unteren Wort
		rlc
		rlc
		ora  e         ;unteres Wort kpl.
		mov  e,a
		inx  h
		mov  d,m
		inx  h
		mov  a,m
		rlc            ;oberes Nibble im
		rlc            ;oberen Wort
		rlc
		rlc
		ora  d         ;oberes Wort kpl.
		mov  d,a
;
		lhld srcend    ;Parameter nachschieben
		shld dstbeg
		lhld srcbeg
		shld srcend
		xchg
		shld srcbeg
		pop  d
		pop h
		pop  psw
		ret
;
hxtest:	lxi  d,0h      ;f.externen Einsprung
hxtst: 	cpi  30h
		jc   hexerr    ;Code zu kein
		ani  5fh       ;Gro~buchstabe
		cpi  1ah       ;"9"+1
		jc   hexcte    ;Code o.k.:JMP
		adi  0c9h      ;A...F adjust
		cpi  10h       ;"F"+1
		jnc  hexerr    ;Code zu gro~:JMP
		cpi  0ah       ;korr. "A"
		jnc  insft     ;A...F: JMP
hexerr:	xra  a         ;FLAGs setzen
		mvi  a,2h      ;kein HEX-Digit
		ret            ;Fehler: Z=1
;
hexcte:	sui  10h       ;Rest der "3x"
insft: 	push h         ;Param. einsammeln
		lxi  h,dowo1   ;Parameter-Buffer
		dad  d         ;Displacement
		mov  m,a
		inx  d
		pop  h
		mov  b,a
		xra  a
		inr  a         ;FLAGs l|schen
		mov  a,b
		ret            ;REG A: HEX-Nibble
;
;
okmsg: 	db 1bh
		db 19h         ;Zeilenrest l|schen
		db " o.k."
		db 0h
ok:    	lxi  h,okmsg
;
postat:	push psw       ;auf Status-Feld positionieren
		push h
		mvi  c,0dh
		call co        ;an Zeilenanfang
		lhld update
		lxi  d,27h
		dad  d
		call crspos
		mvi  c," "
postlp:	call lo        ;Druckkopf rechts
		dcr  e
		jnz  postlp
		pop  h
		call strin     ;Text ausgeben (ohne Release)
		pop  psw
		ret
;
;
errmsg:	db 1bh
		db 19h         ;Zeilenrest l|schen
		db 07h         ;Bell
		db " Error # "
		db 0h
error:	 lxi  h,errmsg
		call postat
		jmp  bytot
;
;
string:	call csts
		jnz  string
strin: 	lxi  b,0ah     ;B:End-Byte; C:CR/LF
strn:  	mov  a,m
		cmp  b
		jnz  stri
		xra  a
		inr  a         ;ZERO off
		ret
stri:  	push b
		mov  c,a
		call co
		cpi  0dh
		jnz  strcte
		pop  b
		push b         ;C:0Dh (=CR) oder 0Ah (=LF)
		call co
strcte:	inx  h
		in   keypor
		mov  c,a
		lda  keybyt
		xra  c
		pop  b
		jz   strn      ;Blank-Key off
		call break
		jmp  strn
;
strinf:	call cstats
		jnz  strinf
		mvi  a,"f"
		sta  levflg
		jmp  string
;
undrln:	mvi  a,80h
		sta  invers
		call string
		xra  a
		sta  invers
		ret
;
;
regsot:	lda  rega      ;RAM(!)-Reg-Buffer darstellen
		call rgout
		lhld regb
		call rpout
		lhld regd
		call rpout
		lhld regh
		call rpout
		lhld regs
		call rpout
		lda  regf
		call space
;
bytbin:	mvi  c,8h      ;ACC bin{r darstellen
bytlop:	rlc
		push psw
		mvi  a,0h
		jnc  bytcte
		inr  a
bytcte:	push b
		call nibot
		pop  b
		pop  psw
		dcr  c
		jnz  bytlop
		ret
;
;
rpout: 	call space
		mov  a,l
		mov  l,h
		mov  h,a
adrot: 	xchg           ;(H&L) ausgeben
		push d
		mov  a,d
		call bytot
		pop  d
		mov  a,e
;
bytot: 	push psw       ;(ACC) ausgeben
		rrc
		rrc
		rrc
		rrc
		call nibot
		pop  psw
;
nibot: 	ani  0fh
		ori  30h
		cpi  3ah
		jc   nibcte
		adi  7h
nibcte:	mov  c,a
		jmp  co
;
rgout: 	call space
		jmp  bytot
;
;
hxlist:	call crlf      ;RAM-HEX-Listing
		lhld hexadr
		call adrot
		call space2
hexlop:	call hexbyt
		lhld hexadr
		xchg
		lhld hexend
		mov  a,e
		cmp  l
		jnz  hexnxt
		mov  a,d
		cmp  h
hexnd: 	rz
hexnxt:	mov  a,e
		ani  3h
		cz   space2
		mov  a,e
		ani  7h
		cz   space2
		jnz  hxcte
		lda  hordsp
		cpi  28h
		jz   hxlist    ;8d Bytes
hxcte: 	mov  a,e
		ani  0fh
		jz   hxlist
		jmp  hexlop
;
hexbyt:	call space
		lhld hexadr
		mov  a,m
		inx  h
		shld hexadr
		call bytot
		jmp  break
;
covid: 	lda  invers
		ora  c
		mov  c,a
coblnk:	in   vidctl
		rrc
		jnc  coblnk    ;Blanking Update
		mov  m,c
		inx  h
		ret
;
crlf:  	lxi  h,crlfms
		jmp  string
crlfms:	db 0dh
		db 00h
;
space2:	call space
space: 	mvi  c," "
		jmp  co
;
;
crspos:	shld update
		mvi  a,0eh
		out  vidreg
		mov  a,h
		ani  0fh
		out  vidat
		mvi  a,0fh
		out  vidreg
		mov  a,l
		out  vidat
		ret
;
crson: 	mvi  a,6ah
		jmp  crsct
crsoff:	mvi  a,20h
crsct: 	push psw
		mvi  a,0ah
		out  vidreg
		pop  psw
		out  vidat
		ret
;
;
break: 	push psw       ;Listop-Abfrage
		push b
		push d
		push h
		call cstats
		jz   brkend    ;no Key
brkin: 	call ci
		cpi  3h
		jz   loklop
		cpi  1bh
		jnz  lokon
loklop:	lxi  h,8h
		dad  sp        ;wg.4xPUSH
		sphl
wstart:	call cstats
		jnz  wstart
		pop  psw       ;RET-Adr.(HI) des aufr.Progr.
		ani  0f0h
		cpi  10h       ;MOVID?
		jz   warm1     ;ja: MEMORY-Menue
		mov  h,a
		mvi  l,3h
		pchl           ;Warmstart
lokon: 	call cstats
		jnz  lokon     ;Key on
lokoff:	call ci
		cpi  3h
		jz   loklop
		cpi  1bh
		jz   loklop
lokout:	call cstats
		jnz  lokout
brkend:	pop  h
		pop  d
		pop  b
		pop  psw
		ret
;
;
init:  	xra  a
		sta  fctcnt    ;FCT-Taste nicht aktiv
		sta  invers    ;Inversdarstellung aus
		lxi  h,0ef90h  ;RAMb=90; RAMe=EF
		shld fdcram    ;wg.Test in SETUP
		out  fdctrl    ;Hilfsbank 0 einstellen
;
		mvi  c,14h
		lxi  d,bcup    ;RAM-Ziel
		lxi  h,bigtab
		in   vidctl
		ora  a
		jm   bigcte    ;Gro~format
		lxi  h,smltab
bigcte:	mov  a,m
		stax d
		inx  h
		inx  d
		dcr  c
		jnz  bigcte
;
		lxi  b,0eh     ;B=00,C=14d
vidlop:	mov  a,b       ;Reg-Nr
		out  vidreg
		mov  a,m       ;Tabellenwert
		out  vidat
		inx  h
		inr  b
		dcr  c
		jnz  vidlop
		ret
;
bigtab:	ds   0h        ;Tab.Gro~format
		dw   3140h
		dw   3190h
		dw   3780h
		dw  0ffb0h
		dw   0050h
		db   50h
		db   18h
		dw   3050h
		dw   36e0h
		dw   3730h
		dw   3730h
;
		db   71h       ;hortot=114-1
		db   50h       ;hordsp
		db   59h       ;horsyn
		db   69h       ;vhpuls
		db   19h       ;vertot=26-1
		db   20h       ;veradj
		db   18h       ;verdsp
		db   18h       ;versyn
		db   30h       ;mode
		db   0bh       ;lines=12-1
		db   6ah       ;crssta
		db   0bh       ;crsend
		db   0h
		db   0h
;
smltab:	ds   0h        ;Tab. Kleinformat
		dw   30a0h
		dw   30c8h
		dw   32d0h
		dw   0ffd8h
		dw   0028h
		db   28h
		db   12h
		dw   3028h
		dw   3280h
		dw   32a8h
		dw   32a8h
;
		db   38h       ;hortot=57-1
		db   28h       ;hordsp
		db   2ch       ;horsyn
		db   25h       ;vhpuls
		db   19h       ;vertot=26-1
		db   01h       ;veradj
		db   12h       ;verdsp
		db   15h       ;versyn
		db   30h       ;mode
		db   0bh       ;lines=12-1
		db   6ah       ;crssta
		db   0bh       ;crsend
		db   0h
		db   0h
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                   ;
;      CO/CI/CSTS  Console Out/In/Status            ;
;                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;   Stand:   Mi,25.02.87;21:57:38h
;
;   Druck:
;
org    1590h
;ofs     590h
;
;
tabs   equ	8h
fctcod equ	0c3h           ;direkter CI-Sprung
;
prtbuf equ	0f800h         ;Copy-Bereich f.Video-RAM
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      CO0  Verarbeitung von ESC-Codes
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
consot: push psw       ;CO0; Escape-Verarbeitung
       push h
       push d
       push b
;
       lxi  h,modflg
       mov  a,m
       ani  10h
       jnz  estest    ;ESC FLAG on
       mov  a,c
       cpi  1bh
       jnz  covido    ;nicht ESC-Key
       mov  a,m
       ori  10h       ;ESC-FLAG setzen
       jmp  escn
;
estest: mov  a,m
       ani  40h       ;ESC-FLAG 2 abfragen
       jz   escte1    ;gel|scht: JMP
       mov  a,c
       sta  escbf1    ;CO-Byte ablegen
       lda  escod     ;ESC-Code holen
       mov  c,a
       jmp  esprcs
escte1: mov  a,m
       ani  20h       ;ESC-FLAG 1 abfragen
       jz   escte2    ;gel|scht: JMP
       mov  a,c
       sta  escbf0    ;CO-Byte ablegen
       mov  a,m
       ori  40h       ;ESC-FLAG 2 setzen
       jmp  escn
escte2: mov  a,c
       cpi  16h       ;TSCPOS?
       jz   escte3
       cpi  1ah       ;TSJUMP?
       jz   escte3
       cpi  1ch       ;PRTINIT?
       jz   escte3
       cpi  1dh       ;PRTOUT?
       jnz  esprcs
escte3: sta  escod
       mov  a,m
       ori  20h       ;ESC-FLAG 1 setzen
       jmp  escn
;
esprcs: mov  a,m
       ani  8fh       ;ESC-FLAGs l|schen
       mov  m,a
       mov  a,c       ;Output-Code
       cpi  20h
escend: jnc  covido    ;ASCII-Zeichen
       cpi  1eh       ;max.+1
       jnc  coend     ;}berschritten: JMP
       cpi  0eh       ;min.
       jc   coend
       lxi  h,coend   ;CTE-Adresse
       push h         ;in den Stack
       lxi  h,esctab
       sui  0eh       ;min.
       rlc
       mov  e,a
       mvi  d,0h      ;D&E: Versatz
       dad  d         ;H&L: Tabellenpointer
       mov  e,m
       inx  h
       mov  d,m
       xchg           ;H&L: Zieladresse
       xra  a
       pchl           ;Verzweigung
;
;
esctab:	ds 0h
;
	dw tsinv0   ;0Eh: Invers aus
	dw tsinv1   ;0Fh: Invers ein
	dw clrvid   ;10h: Schirm l|schen
	dw tshome   ;11h: Cursor home
	dw crsoff   ;12h: Cursor aus
	dw crson    ;13h: Cursor ein
	dw tsro5    ;14h: Scroll up
	dw tsru5    ;15h: Scroll down
	dw tscpos   ;16h: Cursor pos.(LL/CC)
	dw tseeos   ;17h: Schirm ab Cursor l|schen
	dw tselin   ;18h: Zeile l|schen
	dw tseeol   ;19h: Zeile ab Cursor l|schen
	dw tsjump   ;1Ah: JUMP (LO/HI)
	dw tsezu    ;1Bh: Read EZU
	dw tsprin   ;1Ch: Prt.init.j/n;IOFLAG laden
	dw tsprnt   ;1Dh: Printer Ausgabe (2 Bytes)
;
tsinv1: mvi  a,80h     ;Invers-Bit on
tsinv0: sta  invers
       ret
;
tsro5:  lhld bcup
       push h
       pop  b
       lhld hlup
       jmp  scroll
;
tsru5: lhld vidend
       dcx  h
       push h
       pop  b
       lhld bcup
       dcx  h
       xchg
       lhld linz
       dcx  h
dwnlop: in   vidctl    ;Blanking abwarten
       rrc
       jnc  dwnlop
       mov  a,m
       stax b
       dcx  b
       dcx  h
       mov  a,e       ;Endabfrage
       cmp  l
       jnz  dwnlop
       mov  a,d
       cmp  h
       jnz  dwnlop
       ret
;
tscpos: lhld escbf0    ;Cursor positionieren
       xchg           ;D:Spalte; E:Zeile
       lhld linlen
       push h
       pop  b
       lxi  h,vidram  ;Video-Anfang
poslop: dcr  e
       jz   posadd
       dad  b
       jmp  poslop
posadd: mov  c,d
       dad  b
       jmp  crspos
;
tshome: mvi  c,11h     ;ASCII-Home
       jmp  homext
;
tselin: call linanf    ;Zeile l|schen
       jmp  clrlin
;
tseeos: lhld vidend    ;Schirm ab Cursor l|schen
       jmp  tseect
;
tseeol: lhld linlen    ;Zeile ab Cursor l|schen
       push h
       call linanf
       pop  b
       dad  b
tseect: xchg           ;D&E: Zeilenende +1
       lhld update    ;H&L: Cursor-Position
       jmp  clear
;
linanf: lhld lininv    ;H&L auf Zeilenanfang
       push h
       pop  b
       lhld update
       xchg
       lhld vidend
clrlop: mov  a,h       ;H&L: Zeilenanfang
       cmp  d         ;UPDATE
       rc
       jnz  clrct
       mov  a,l
       cmp  e
       rc             ;H&L: Anfang Cursorzeile
       rz
clrct: dad  b
       jmp  clrlop
;
tsjump: lhld escbf0
       pchl
;
tsezu: di
       call time
       ei
       jmp  string
;
tsprin: lda  escbf0
       ora  a
       cnz  loinit
       lda  escbf1
       sta  ioflag
       ret
;
tsprnt: lda  escbf0
       mov  c,a
       call lo
       lda  escbf1
       mov  c,a
       jmp  lo
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      CO1  Video- und Drucker-Ausgabe
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
covido: lhld update    ;CO1; Video-Ausgabe
       lxi  d,cocnt1
       push d
       mov  a,c
       ani  7fh
       mov  c,a
       cpi  " "
       jc   coctl1    ;kleiner Blank (20h)
       cpi  7fh
       jz   del
;
       jmp  covid     ;nur Video-Out; H&L:Vid-Pointer
cocnt1: call crscmp    ;Cursor update/posit.
;
cocnt2: lxi  d,coend
       push d
coprt: lda  ioflag    ;nur Printer-Ausgabe
       ani  0f0h
       rz
       jmp  lo
;
escn:  mov  m,a       ;ESC-Ende ohne Video-Out
coend: pop  b
       pop  d
       pop  h
       pop  psw
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Verarbeitung der Bildschirm-Steuerzeichen
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
coctl1: cpi  08h       ;CTL+H; druckbare Codes
       jnz  lfd
del:   dcx  h
       call crscmp
       mvi  c," "
       call covid
       call crscmp
       dcx  h
       call crscmp
       ret
;
lfd:   cpi  0ah       ;CTL+J
       jz   linfed
;
cls:   cpi  0ch       ;CTL+L
       jz   clrvid
;
crt:   cpi  0dh       ;RET
       jnz  coctl0
       call linanf
       mvi  c,0dh
       ret
;
;
coctl0: pop  d         ;nicht druckbare Codes
       lxi  d,coend
       push d
       ora  a
       rz             ;00h unterdr}cken
;
bel:   cpi  7h        ;CTL+G
       jnz  tab
       out  belpor
       rz
;
tab:   cpi  9h        ;CTL+I
       jnz  cocrs
       mvi  b,tabs
tablop: mvi  c," "
       call covid
       call crscmp
       dcr  b
       jnz  tablop
       ret
;
cocrs: push h         ;Cursor-Codes
       lxi  h,0h
       dad  sp
       mov  a,h
       pop  h
       cpi  2eh
       jc   cout      ;kein Monitor-Stack
;
homext: lxi  d,crscmp
       push d
       mov  a,c
;
rig:   cpi  04h       ;CTL+D
       jnz  lef
       inx  h
       ret
;
lef:   cpi  13h       ;CTL+S
       jnz  hom
       dcx  h
       ret
;
hom:   cpi  11h       ;CTL+Q
       jnz  upw
       lxi  h,vidram
       ret
;
upw:   cpi  05h       ;CTL+E
       jnz  dwn
       lda  hordsp
       mov  b,a
       call crsoff
upwlop: dcx  h
       call crscmp
       dcr  b
       jnz  upwlop
       jmp  crson
;
dwn:   cpi  18h       ;CTL+X
       jnz  cout
       lda  hordsp
       mov  b,a
       call crsoff
dwnlp: inx  h
       call crscmp
       dcr  b
       jnz  dwnlp
       jmp  crson
;
cout:  call covid
crscmp: mov  a,h
       cpi  2fh
       jnz  crscte    ;innerhalb Bildfenster
       lhld vidend
       dcx  h
       jmp  crspos
crscte: xchg
       lhld vidend
       xchg
       mov  a,d
       cmp  h
       jnz  crspos
       mov  a,e
       cmp  l
       push b
       cz   caret
       pop  b
       jmp  crspos
;
;
caret: call linanf
       shld update
linfed: xchg
       lhld linlen
       dad  d
       call extern
linret: mvi  c,0ah
       rc             ;nur LF
;
       lxi  b,vidram
       lhld lin2
scroll: in   vidctl    ;bis VIDEND eine Zeile hoch
       rrc
       jnc  scroll
       mov  a,m
       stax b
       inx  h
       inx  b
       call extern
       jc   scroll
       lhld linz
       call clrlin    ;unterste Zeile l|schen
       lhld update
       mvi  c,0ah
       ret
;
extern: xchg           ;H&L im Bildfenster?
       lhld vidend
       mov  a,d
       cmp  h
       jc   extend
       jnz  extend
       mov  a,e
       cmp  l
extend: xchg
       ret
;
;
clrvid: lhld vidend
       xchg
       lxi  h,vidram
       jmp  clear
clrlin: xchg
       lhld linlen
       dad  d
       xchg
clear: mvi  c," "
       push h
clrlp: call coblnk    ;ins Video-RAM
       mov  a,d
       cmp  h
       jnz  clrlp
       mov  a,e
       cmp  l
       jnz  clrlp
       mvi  c,0ch
       pop  h
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      CI   Console-Eingabe
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
consin: lda  fctcnt    ;Monitor-CI
       ora  a
       jnz  ci
conslp: call cstats    ;auf Loslassen warten
       jnz  conslp
;
ci:    push h         ;liefert ASCII-Code in Reg.A
       push d
       push b
ci0:   lxi  h,endci   ;CTE-Adresse
       push h
;
ci1:   lda  fctcnt    ;FCT-Mode aktiv?
       ora  a
       jz   ci2lop    ;nein: JMP
       dcr  a
       sta  fctcnt
       lhld fctpoi
       mov  a,m       ;CI-Code aus dem RAM
       inx  h
       shld fctpoi
       ret            ;zu ENDCI
;
ci2lop: call cstats
       jz   ci2lop
       lda  timprl    ;Prellzeit in ms
ci3lop: call dely1
       dcr  a
       jnz  ci3lop
       call cstats    ;Tastenmatrix abfragen
       jz   ci2lop
;
       lhld hibuf     ;Inputs holen
       mov  e,l
       mvi  d,0h      ;D&E: Tasten-Nr
       mov  a,h       ;Inputs holen
       ani  20h       ;FCT-Spalte
       jnz  funct
;
       mov  a,h
       mvi  b,0a0h    ;CTRL-Offset
       ani  80h       ;CTRL-Spalte
       jnz  ioinv
;
ci4:   mov  a,h
       mvi  b,50h     ;SHIFT-Offset
       ani  40h       ;SFT-Spalte
       jnz  getcod
       lda  ioflag
       rrc            ;SHIFT LOCK?
       jc   getcod
;
       mvi  b,0h      ;kein Offset
getcod: lxi  h,asctab
       dad  d         ;H&L: Bereichspointer
       mov  e,b
       dad  d         ;H&L: Tabellenpointer
       mov  a,m       ;ASCII-Code aus Tabelle
       ret
;
endci: pop  b
       pop  d
       pop  h
       ret
;
;
;;;
;
;      I/O-FLAGs invertieren
;
;;;
;
ioinv: mvi  d,1h      ;Bit-Zeiger
       lxi  h,iotab   ;Key-Codes 7...1
       mvi  c,7h
ioloop: mov  a,d
       rrc
       mov  d,a
       mov  a,e
       cmp  m
       jz   invert
       inx  h
       dcr  c
       jnz  ioloop
       mvi  d,0h      ;Fehlanzeige
       jmp  getcod
;
invert: push d
inrels: call cstats
       jnz  inrels
       pop  psw
       lhld update
       push h         ;save Cursor Pos.
       lxi  h,ioflag
       xra  m         ;I/O-Bit invertieren
       push h
       push psw       ;und I/O-Byte retten
       ani  0fh
       mov  m,a       ;kein Paralleldruck
       lxi  h,iotxt
       call postat    ;Text im Statusfeld ausgeben
       pop  psw
       push psw
       call bytbin    ;neues I/O-Byte ausgeben
iorls: call cstats
       jnz  iorls
       call loinit    ;Drucker init.
       pop  psw
       pop  h
       mov  m,a       ;neues I/O-Byte ablegen
       pop  h
       call crspos    ;alte Cursor-Pos.
       jmp  ci1
;
iotab: db   00h ;7
       db   14h
       db   0ah
       db   1eh
       db   05h
       db   19h
       db   0fh ;1
;
iotxt: db 1bh
       db 19h         ;Zeilenrest l|schen
       db " I/O-FLAGs: "
       db 0h
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Verarbeitung der Funktionstaste
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;  FCT-Key: Liefert vier aufeinander folgende
;           Codes aus dem Code-Buffer im RAM
;           FCT+U:EZU; FCT+V:Video Copy
;           bei C3h im FCT-Buffer erfolgt JMP
;
funct: lxi  h,codtab
       dad  d
       dad  d
       dad  d
       dad  d
       shld fctpoi    ;H&L: 4 Bytes Offs.pro Taste
       lxi  d,fctcnt
;
       mov  a,h
       cpi  2bh
       jnz  fcte
       mov  a,l
       cpi  0ch
       jz   fctezu    ;H&L: FCT+U=Read EZU
       cpi  80h
       jz   fctcpy    ;H&L: FCT+V=Copy Video-RAM
;
fcte:  mvi  a,4h      ;f}r 4 Code-Bytes!
       stax d
       mov  a,m
       cpi  fctcod    ;direktes CI-Sprungziel?
       pop  b         ;RET-Adr.
       jnz  ci0       ;4 FCT-Codes holen
       push b
;
       xra  a
       stax d         ;FCT-Z{hler l|schen
       inx  h
       mov  e,m
       inx  h
       mov  d,m
       xchg
fctrls: call cstats
       jnz  fctrls
       pchl           ;H&L: Direktes Sprungziel
;
fctezu: di
       mvi  a,15h     ;21d Stringl{nge
       stax d
       call time
       shld fctpoi    ;String-Anfang
       mvi  a," "     ;Blank f.R}cksprung
       ei
       ret
;
fctcpy: lxi  h,vidram
       shld srcbeg
       lhld vidend
       mvi  m,0h      ;String-Ende
       shld srcend
       lxi  h,prtbuf
       shld dstbeg
       call copy
       jmp  ci1
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      CSTS   Console Status
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      liefert ZERO on, wenn keine Taste aktiv ist
;
;      liefert ZERO off bei aktiver ASCII-Taste
;      sowie im Hilfsbuffer HIBUF die Inputs:
;      REG H: Input (3 MSB) sowie Zeilen-Nr.
;      REG L: aktuelle Tasten-Nr. 00...4Fh
;
cstats: lda  fctcnt    ;Monitor-CSTS
       ora  a
       jz   csts0
       xra  a
       ret            ;Key off bei FCTCNT on
;
csts:  lda  fctcnt    ;externes CSTS
       ora  a
       jz   csts0
       xra  a
       dcr  a
       ret            ;Key on bei FCTCNT on
;
csts0: push h
       push d
       push b
       lxi  h,csret
       push h
;
       mvi  b,0h
       lxi  h,hibuf   ;Input-Hilfsroutine
       mvi  m,0dbh    ;"IN"
       inx  h
       inx  h
       mvi  m,0c9h    ;"RET"
       dcx  h         ;H&L: RAM-Zelle f.Portadr.
       mvi  m,0fch    ;oberste Key-Portadresse
       mvi  c,0fh     ;Zeilenz{hler
cstlop: call hibuf     ;Key-Port einlesen
;
       push h
       lxi  h,keybyt  ;und bei Bedarf
       xra  m         ;invertieren
       pop  h
;
       mov  d,a       ;REG D: Input-Daten
       ani  1fh       ;3 MSB ausblenden
       jnz  csts1     ;key: JMP
       mov  a,m       ;Portadresse holen
       sui  10h       ;erniedrigen
       mov  m,a       ;und wieder ablegen
       dcr  c         ;Zeilenz{hler erniedrigen
       jp   cstlop    ;nicht fertig: JMP
keyoff: xra  a
       ret            ;no key: ACC=00h, ZERO on
;
csts1: rrc            ;Spalte bin{r umsetzen
       jc   cstnd
       inr  b
       jmp  csts1
cstnd: mov  a,c
       rlc
       rlc
       add  c         ;Zeilen-Nr. ;5
       add  b         ;plus Spalten-Nr.
       mov  e,a
;
csts2: lxi  h,ioflag
       cpi  2fh       ;SHIFT LOCK?
       jnz  csts3
       mvi  a,1h
       xra  m         ;LSB invertieren
       mov  m,a
       out  belpor    ;Quittung: Bell
       lxi  h,keybyt
relop: in   9ch       ;S.L.-Zeile abfragen
       xra  m
       jnz  relop
       call dely1
       in   9ch
       xra  m
       ani  1fh       ;Key-Spalten maskieren
       jnz  relop
       ret            ;de facto: no key
;
csts3: mov  a,d       ;Input-Daten holen
       ani  0e0h      ;3 MSB maskieren
       ora  c         ;mit Z{hlerstand verkn}pfen
       mov  d,a
       xchg
       shld hibuf
keyon: xra  a
       dcr  a         ;key: ACC=FFh, ZERO off
       ret
csret: pop  b
       pop  d
       pop  h
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;                                                   ;
;      PERIPH  Peripherie- und Speicherverwaltung   ;
;                                                   ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;   Stand:   Mi,04.03.87;06:20:12h
;
;   Druck:
;
	org    1a00h
;ofs    0a00h
;
;
vidofs equ	0bh
;
defbuf equ	8000h ;Default Input Buffer
;
;
stx    equ	02h  ;CTL+B
etx    equ	03h  ;CTL+C
ramin  equ	09h  ;CTL+I; Input-RAM parallel
ramot  equ	0fh  ;CTL+O; Output-RAM parallel
ramof  equ	15h  ;CTL+U; RAM abtrennen
xon    equ	11h  ;CTL+Q (=DC1)
cont   equ	xon
xof    equ	13h  ;CTL+S (=DC3)
stop   equ	xof
exit   equ	1ah  ;CTL+Z
;
questp    equ	20h         ;DF]-Konstanten
queovf    equ	28h
;
rigt   equ	04h            ;MEM/STEP-Konstanten
left   equ	13h
down   equ	18h
;upw    equ	05h
;tabs   equ	09h
;
limitr equ	0705h ;Limits MEMORY:05/07d
limits equ	2708h ;Limits SSTEP:08/39d
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Vollduplex-Terminal-Betrieb
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
termnl: call queini    ;Randbedingungen herstellen
       call dfueini
       lxi  h,termtx
       call string    ;Kopfzeilen
       lda  hordsp
strokl: mvi  c,"-"
       call co
       dcr  a
       jnz  strokl
       lhld srcbeg
       mov  a,l
       ora  h
       jnz  termn
       lxi  h,defbuf
termn:  shld recpoi
       lhld srcend
       shld txmpoi
       lhld liny
       call crspos
;
mainlp: ei
       lxi  h,mainlp
       push h
receiv: call status    ;Kopfzeilen aufdatieren
       call quered    ;Zeichen holen
       cnz  procin    ;Eingabe verarbeiten
;
reles: lda  keylok
       ora  a
       jz   trsmit    ;Tastatur frei
       call cstats
       rnz            ;Tastatur blockiert
       xra  a
       sta  keylok    ;Tastatur freigeben
trsmit: call cstats
       jz   output    ;no key; test Auto-RAM-Output
       sta  keylok    ;Taste aktiv, Tastatur sperren
       call ci
       mov  b,a
;
       lxi  d,stx     ;D:00h; E:02h
       lxi  h,raminf  ;Input-RAM
       mov  c,d
       cpi  ramof
       cz   proxnd    ;aus und ETX einf}gen
       mov  c,e
       cpi  ramin
       jz   procnd    ;ein
;
       lxi  h,ramotf  ;Output-RAM
       mov  c,d
       cpi  ramof
       jz   procnd    ;aus
       mov  c,e
       cpi  ramot
       jz   procnd    ;ein
;
       cpi  cont      ;Stop/Cont senden?
       jz   sendon
       cpi  stop
       jz   sendof
;
       cpi  exit      ;Monitor-R}cksprung?
       mov  c,b
       jnz  outpt     ;nein
mowait: call cstats
       jnz  mowait
       pop  psw       ;Stack-Ausgleich
       ret
;
output: lda  ramotf    ;Auto-RAM-Output?
       cpi  stx
       rnz            ;nein
       lhld txmpoi
       mov  a,m
       mvi  c,0ah     ;LF
       cpi  0dh       ;CR
       jz   outpt     ;vor 'Ret' ein 'Linefeed'
       mov  c,a
       inx  h
       shld txmpoi
       cpi  etx
       jnz  outpt     ;noch kein 'End of Text'
       sta  ramotf
outpt: lda  txmflg
       cpi  xof
       rz             ;XOF von Gegenstelle aktiv
       lda  dsrflg
       ora  a
       jnz  v24out    ;DSR o.k.
outer: out  belpor    ;kann nicht senden
       ret
;
;
status: lxi  h,dsrflg  ;Kopfzeilen aufdatieren
       mvi  m,"d"
       in   serctl
       ani  4h
       jz   statu
       mvi  m,0h
statu: lxi  h,ctsflg
       mvi  m,"c"
       in   serctl
       ani  8h
       jz   stat1
       mvi  m,0h
stat1: lhld lin2
       lxi  d,vidofs
       dad  d         ;H&L:Vid-Pointer Txm-Zeile
       push h
       lxi  d,ctsmsg
       lxi  b,ramotf
       lda  ctsflg
       call lineot
       lda  recflg
       call statrt
stat2: pop  d
       lhld linlen
       dad  d         ;H&L:Vid-Pointer Rec-Zeile
       lxi  d,dsrmsg
       lxi  b,raminf
       lda  dsrflg
       call lineot
       lda  txmflg
       jmp  statrt
;
;
lineot: push b
       ora  a
       call statot    ;CTS/DSR
       pop  b
       ldax b         ;TXM/REC-FLAG
       ora  a
pointo: jz   statot
;
       xchg           ;TXM/REC-Pointer anzeigen
       call crsoff
       lhld update
       push h         ;save UPDATE
       xchg
       shld update    ;set UPDATE'
       inx  b
       ldax b
       mov  l,a       ;Pointer (LO)
       inx  b
       ldax b
       mov  h,a       ;Pointer (HI)
       call adrot
       call space2
       lhld update
       xchg
       pop  h
       call crspos    ;restore UPDATE
       call crson
       xchg           ;H&L: UPDATE'
       ret
;
statrt: lxi  d,xonmsg
       cpi  xon
       jz   stato
       xra  a
statot: jnz  stato     ;Text oder '---'
       lxi  d,strmsg
stato: ldax d
       ora  a
       rz
       mov  c,a
       call covid
       inx  d
       jmp  stato
;
;
procin: mov  c,a       ;Zeichen vom Queue
       cpi  0ah
       jz   scrol     ;bei LF Scrollup
       call co
;
       lxi  h,txmflg  ;Stop von Gegenstelle?
       cpi  xon
       jz   procnd
       cpi  xof
       jz   procnd
;
       lxi  h,raminf  ;RAM parallel schalten?
       cpi  stx
       jz   procnd
       cpi  etx
       jz   procnd
;
       mov  a,m       ;Daten auch ins RAM?
       cpi  stx
       rnz            ;nein
       lhld recpoi
       mov  m,c
       inx  h
       shld recpoi
       ret
;
proxnd: push h
       lhld recpoi
       mvi  m,etx     ;Empfangstext definiert abschl
       pop  h
procnd: mov  m,c       ;save/change FLAG
       ret
;
scrol: mvi  c,1bh     ;Scrolling from line 4
       call co
       mvi  c,14h
       jmp  co
;
;
sendon: mvi  c,xon     ;Receive-Line on/off
       jmp  sendct
sendof: mvi  c,xof
sendct: lxi  h,recflg
       mov  a,m
       cmp  c
       rz             ;XON/XOF wurde bereits gesendet
       mov  m,c
       jmp  outpt     ;Gegenstelle testen!
;
v24out: push psw
v24lop: in   serctl
       ani  0ch       ;Data Carrier/CTS
       jnz  v24lop    ;Gegenstelle nicht bereit
v24ond: in   serctl
       ani  2h
       jz   v24ond    ;Transm.Reg.not empty
       mov  a,c
       out  serdat    ;zu }bertragendes Byte ausgeben
       pop  psw
       ret
;
;
v24in: in   serctl    ;6850 Status
       ani  31h
       cpi  1h
       jz   v24ind    ;Rec.Reg.full, no errors
       in   serctl
       in   serdat    ;clear Error-FLAGs
       jmp  v24in
v24ind: in serdat      ;empfangenes Byte auslesen
       ret
;
;
quered: lxi  h,queofs  ;Queue lesen
       xra  a
       cmp  m
       rz             ;Queue empty
       di
       dcr  m
       inx  h         ;H&L: Queue-Bottom
       push h
       pop  d
       inx  d
       mvi  c,queovf
       dcr  c
       mov  b,m       ;save first Char.
readlp: ldax d
       mov  m,a
       inx  h
       inx  d
       dcr  c
       jnz  readlp
       xra  a
       stax d         ;clear Queue-Top
       inr  a         ;ZERO off (Queue not empty)
       mov  a,b       ;first Char.
       ei
       ret
;
queini: lxi  h,int75   ;Programm initialisieren
       mvi  m,0c3h    ;JMP
       inx  h
       lxi  d,isr75
       mov  m,e
       inx  h
       mov  m,d
;
       mvi  a,0bh
       sim            ;RST7.5 enable
       nop
       mvi  a,8h
       out  0bbh      ;RST A enable
;
       lxi  h,linbuf  ;80d-RAM-Buffer l|schen
       mvi  c,50h
clearl: xra  a
       mov  m,a
       inx  h
       dcr  c
       jnz  clearl
       ret
;
;
isr75: push psw       ;6850-Interrupt (Pin 7->RST75)
       push h
       push d
       push b
       mvi  a,0d5h
       out  serctl    ;reset RTS
       in   serctl
       mov  b,a       ;get Status
       ani  30h
       mvi  c,8h      ;Err 8:Framing/Overrun
       jnz  isrer
       mov  a,b
       ani  1h
       jz   isrerr    ;kein Byte empfangen: Fehler
       dcr  c         ;Err 7:Queue-Overflow
       lxi  h,queofs
       mov  a,m
       cpi  queovf
       jnc  isr       ;Queue }bergelaufen
;
       cpi  questp    ;Queue f}llen
       cnc  sendof    ;Queue-Stopmarke erreicht
       mov  e,m       ;E: Queue-Offset
       inr  m
       mvi  d,0h
       inx  h         ;H&L:Queue-Anfang
       dad  d         ;H&L:Queue-Pointer
       in   serdat
       mov  m,a       ;empfangenes Byte ablegen
       jmp  isrend
;
isrerr: dcr  c         ;Err 6:unbekannter Interrupt
       mov  a,b
       ani  4h
       jz   isr
       dcr  c         ;Err 5:DSR inaktiv
       in   serctl    ;clear DCD-Interrupt
isrer: in   serdat    ;Dummy Read
isr:   mov  a,c
       jmp  isrnd
isrend: xra  a
isrnd: sta  erinfl    ;Error-FLAG
       mvi  a,95h
       out  serctl    ;set RTS
       pop  b
       pop  d
       pop  h
       pop  psw
       ei
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Ansteuerung der Echtzeit-Uhr
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
uhrint: di
       lhld srcbeg
       mov  a,h
       ora  l
       jz   rdezu     ;Nulleingabe
wrezu: push h         ;Uhr stellen
       lhld srcend
       mov  b,h       ;B:Wo'tag
       mov  c,l       ;C:Kal'tag
       lhld dstbeg
       xchg           ;D:Monat; E:Jahr
       pop  h         ;H:Std.;  L:Min.
       call writur
;
rdezu: lxi  h,int65   ;Uhr lesen
       mvi  m,0c3h    ;JMP
       inx  h
       lxi  d,isr65
       mov  m,e
       inx  h
       mov  m,d
       mvi  a,1dh
       sim            ;RST6.5 enable
       nop
       mvi  a,4h
       out  0bbh      ;RST B enable
;
       call crlf
       call time
       lxi  h,ascbuf
       call string    ;wg.ev.Protokolldruck
;
;
isr65: push psw       ;ISR; ca.3 ms bei 6 MHz
       push h
       push d
       push b
;
       lhld second
       inx  h         ;max.18h:12m:16s
       shld second
;
       call time      ;Bildschirmeinblendung
       xchg           ;D&E:Stringanfang
       lhld lin2
       lxi  b,0ffebh
       dad  b         ;Bildpos.oben rechts
isrlop: ldax d
       inx  d
       ora  a
       jz   isred
       mov  c,a
       call covid     ;kein String wg.Paralleldruck
       jmp  isrlop
isred: pop  b
       pop  d
       pop  h
       pop  psw
       ei
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Speicherbereiche vergleichen
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
revise: mvi  a,"o"
       sta  hexadr    ;OK-FLAG
revis: lhld srcbeg
       xchg
       lhld dstbeg
       ldax d
       cmp  m
       cnz  diflst    ;Differenz listen
       inx  h
       shld dstbeg
       xchg
       inx  h
       shld srcbeg
       xchg
       lhld srcend    ;Endabfrage
       inx  h
       mov  a,e
       cmp  l
       jnz  revis
       mov  a,d
       cmp  h
       jnz  revis
       lda  hexadr
       ora  a
       rz
       jmp  ok
;
diflst: xra  a
       sta  hexadr    ;clear OK-FLAG
       push d
       push h
       call crlf
       lhld srcbeg    ;Source
       mov  a,m
       push psw
       call adrot     ;SSSS=
       mvi  c,"="
       call co
       pop  psw
       call bytot     ;    =ss
       call space2
       lhld dstbeg    ;Destination
       mov  a,m
       push psw
       call adrot     ;DDDD:
       mvi  c,":"
       call co
       pop  psw
       call bytot     ;    :dd
       pop  h
       pop  d
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Speicher inspizieren und modifizieren
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
memory: call srcnul    ;Nulleingabe ->2800h
       lxi  h,limitr
       lxi  d,ramsg
       mvi  a,"r"     ;RAM/STEP-Mode
       call memini
       jmp  memlop
;
;
memini: shld limin     ;Grenzwerte li/re
       mvi  h,0h
       shld dsplcm
       sta  memflg
       lxi  h,vidram
       call crspos
       xchg
       call string
       lhld update
       shld linbeg
       lhld srcbeg
       shld adres
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Einzelschritt-Betrieb im RAM
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
sinstp: call brkini
       jmp  bresto    ;D7h einsetzen und Start
;
memlop: lhld update    ;save UPDATE
       push h
       lda  ioflag
       push psw
       ani  0fh
       sta  ioflag    ;Paralleldruck aus
       lxi  h,linbuf
       shld update    ;Video-Ausgabe in RAM-Buffer
       lhld adres
       mov  a,m
       push psw
       call adrot     ;Adresse
       call space
       pop  psw
       call bytot     ;Inhalt
       lda  memflg
       cpi  "s"
       cz   regsot
       lhld update
       mvi  m,0h      ;String-Ende
       pop  psw
       sta  ioflag    ;Paralleldruck wieder ein
       pop  h
       shld update    ;restore UPDATE
       lxi  h,linbuf  ;String-Anfang beim RAM-Buffer
       call string
       lxi  sp,stack  ;User-Stack belassen
;
memlp: lhld linbeg
       xchg
       lhld dsplcm
       dad  d
       call crspos    ;Cursor linksb.(Inh./REG A)
       call crson
;
       call consin
       cpi  "m"
       jz   warm1
       cpi  "M"
       jz   warm1
       cpi  0dh       ;kein Blank wg.Anhalten!
       jz   next
       cpi  down
       jz   next
       lxi  d,memlp
       push d
       cpi  rigt
       jz   right
       cpi  left
       jz   lefht
       cpi  tabs
       jz   tabul
       cpi  "-"
       jz   backst
       cpi  05h
       jz   backst
       push psw
       call hxtest
       pop  b
       jz   error
       mov  c,b       ;Input
       call covid     ;darstellen
       lhld dsplcm
       lxi  d,linbuf
       dad  d
       mov  m,c       ;und im LINBUF ablegen
;
right: lxi  h,dsplcm
       mov  a,m
       inr  a
       mov  m,a
       lda  limax
       dcr  a
       cmp  m
       jnc  righnd
       lda  limin
       mov  m,a
righnd: call blktst
       jz   right
       ret
;
lefht: lxi  h,dsplcm
       mov  a,m
       dcr  a
       mov  m,a
       lda  limin
       dcr  a
       cmp  m
       jc   leftnd
       lda  limax
       dcr  a
       mov  m,a
leftnd: call blktst
       jz   lefht
       ret
;
tabul: call right     ;TAB=2xRight
       jmp  right
;
blktst: lhld dsplcm
       lxi  d,linbuf
       dad  d
       mov  a,m
       cpi  20h       ;Blank?
       ret
;
backst: lda  memflg
       cpi  "r"
       mvi  a,1h
       jnz  error     ;im RAM-Mode nicht m|glich
       call crlf
       call crlf
       lhld update
       shld linbeg
       lhld adres
       dcx  h
       jmp  nxtret
;
next:  call crlf
       lhld update
       shld linbeg
       lxi  h,linbuf  ;LINBUF in REGBUF }bertragen
       lda  limin
       mov  e,a
       mvi  d,0h
       dad  d         ;H&L: REG A im LINBUF
       lxi  d,rega    ;D&E: REG A im REGBUF
       call regsub    ;A
       lda  memflg
       cpi  "s"
       jz   nxtstp
;
nxtram: lhld adres     ;RAM-Mode: nur ein BYTOT
       lda  data
       mov  m,a
       mov  b,m
       cmp  b
       jnz  nxterr    ;Fehler beim Einschreiben
       inx  h
nxtret: shld adres
nxtcte: lda  limin
       sta  dsplcm
       jmp  memlop
nxterr: mvi  a,19h
       call error
       mvi  c,0dh
       call co
       jmp  nxtcte
;
nxtstp: call rpsub     ;B&C/D&E
       inx  d
       call rpsub     ;H&L/SP
       call flgsub    ;FLAGs
       jmp  restor
;
;
rpsub: inx  h         ;8 BYTOT
       call rgrgsb
       inx  h
;
rgrgsb: call regsub    ;4 BYTOT
;
regsub: push d         ;2 BYTES
       mov  a,m
       push h
       call hxtest    ;nur umsetzen, kein Test
       pop  h
       rlc
       rlc
       rlc
       rlc
       mov  b,a       ;REG B: erstes Nibble (linksb.)
       inx  h
       mov  a,m
       push h
       push b
       call hxtest    ;nur umsetzen, kein Test
       pop  b
       pop  h
       ora  b         ;REG A: beide Nibbles
       pop  d
       stax d
       sta  data
       inx  d
       inx  h
       ret
;
flgsub: inx  h
       lxi  b,8h      ;B=00h; C=08h
flglop: mov  a,m
       ani  1h
       push psw
       rrc
       pop  psw
       jnz  flgcte
       xra  a
flgcte: ora  b
       rlc
       mov  b,a
       inx  h
       dcr  c
       jnz  flglop
       mov  a,b
       rrc
       sta  regf
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Breakpoint-Betrieb im RAM
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
breakp: call brkini    ;Breakpoints vorbereiten
       lhld srcend
       shld adres
bresto: shld brkpt1
       mov  a,m
       sta  opcod1    ;OpCode retten
       mvi  m,0d7h    ;und durch RST2 ersetzen
       lda  regf
       mov  c,a
       push b
       pop  psw       ;CPU-FLAGs setzen
       lhld regs
       mov  a,l
       mov  l,h
       mov  h,a
       sphl           ;CPU-SP setzen
       lxi  h,regb
       mov  b,m       ;CPU-REG B
       inx  h
       mov  c,m       ;CPU-REG C
       inx  h
       mov  d,m       ;CPU-REG D
       inx  h
       mov  e,m       ;CPU-REG E
       lhld srcbeg
       push h         ;Startadresse
       lhld regh
       mov  a,l
       mov  l,h
       mov  h,a       ;CPU-REGs H&L
       lda  rega      ;CPU-REG A
       ret            ;Start bis Breakpoint
;
;
brkini: call srcnul    ;Nulleingabe ->2800h
       lxi  h,limits
       lxi  d,stpmsg
       mvi  a,"s"     ;STEP/RAM-Mode
       call memini
       push h
       lxi  h,memlop  ;Breakpoints vorbereiten
       shld hbuf2
       mvi  a,0c3h    ;JMP
       sta  hibuf2
       lda  modflg
       ani  0f7h      ;clear FCT-FLAG
       ori  80h       ;set STP-FLAG
       sta  modflg
       xra  a
       sta  regf      ;CPU-FLAGs l|schen
       lxi  h,0h
       shld brkpt1    ;Break-Adr.l|schen
       shld brkpt2
       pop  h
       ret
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Klartext-Meldungen
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
termtx: db 1bh         ;TERMINAL
       db 10h ;clear Screen
       db 1bh
       db 11h ;home
       db "MOPPEL-Terminal  V 15.6  (C) hms'86"
       db 0dh
       db "Transmit: "
       db 0dh
       db "Receive:  "
       db 0dh
       db 1bh
       db 13h ;Cursor on
       db 0h
;
dsrmsg: db "DSR  "
       db 0h
;
ctsmsg: db "CTS  "
       db 0h
;
xonmsg: db "XON  "
       db 0h
;
strmsg: db "---  "
       db 0h
;
;
ramsg: db 1bh         ;MEMORY
       db 10h ;clear Screen
       db 0dh
       db "Adr.Inh."
       db 0dh
       db 0dh
       db 0h
;
stpmsg: db 1bh         ;SINGLE STEP
       db 10h ;clear Screen
       db 0dh
       db "Adr.Inh.A  B&C  D&E  H&L   SP  SZxcxPxC"
       db 0dh
       db 0dh
       db 0h
;
;
;####################################################
;
; nachfolgende Programmteile stehen
; im Monitor rot (Platz 0)
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Klartext-Meldungen
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
	org    menue0m	;Ende 0-ROM [0D28h]
;				;Buffer ab 28xxh
;
menue0: 	db 	1bh
		db 	11h ;Home
		db 	1bh
		db 	17h ;clear Screen
		db 	"MOPPEL-Video-Monitor V 7.6"
		db 	0dh
		db 	"Copyright (C) hms'86"
		db 	0dh
		db 	0dh
		db 	"M: Memory"
		db 	0dh
		db 	"O: Outward"
		db 	0dh
		db 	"P: Peripheral"
		db 	0dh
		db 	"S: Start"
		db 	0h
;
menue1: 	db 	0dh
		db 	0dh
		db 	"C: Copy"
		db 	0dh
		db 	"F: Fill"
		db 	0dh
		db 	"K: Kill"
		db 	0dh
		db 	"L: List"
		db 	0dh
		db 	"M: Memory"
		db 	0dh
		db 	"R: Revise"
		db 	0dh
		db 	"T: Text"
		db 	0dh
		db 	"X: Exchange"
		db 	0h
;
menue2: 	db 	0dh
		db 	0dh
		db 	"A: Assembler"
		db 	0dh
		db 	"B: BASIC"
		db 	0dh
		db 	"D: Disassembler"
		db 	0dh
		db 	"E: Editor"
		db 	0dh
		db 	"F: Floppy"
		db 	0dh
		db 	"P: Prommer"
		db 	0dh
		db 	"X: Ext.2000h"
		db 	0h
;
menue3: 	db 	0dh
		db 	0dh
		db 	"I: Cass-In"
		db 	0dh
		db 	"O: Cass-Out"
		db 	0dh
		db 	"T: Terminal"
		db 	0dh
		db 	"U: Uhr"
		db 	0dh
		db 	"V: V.24-In"
		db 	0dh
		db 	"W: V.24-Out"
		db 	0h
;
menue4: 	db 	0dh
		db 	0dh
		db 	"G: Go"
		db 	0dh
		db 	"S: Step"
		db 	0dh
		db 	"U: User F000h"
		db 	0dh
		db 	"Y: Byte"
		db 	0dh
		db 	"Z: Break"
		db 	0h
;
promp0:	db 	0dh
		db 	0dh
		db 	"M>"
		db 	0h
;
promp1:	db 	0dh
		db 	0dh
		db 	"Mm>"
		db 	0h
;
promp2:	db 	0dh
		db 	0dh
		db 	"Mo>"
		db 	0h
;
promp3:	db 	0dh
		db 	0dh
		db 	"Mp>"
		db 	0h
;
promp4:	db 	0dh
		db 	0dh
		db 	"Ms>"
		db 	0h
;
;
;####################################################
;
;      Tabelle der ASCII-Codes; Normal Codes
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
	org    asctab         ;Ende 0-ROM [0F10h]

;
	db "7"      ;Spalte 0
	db "j"
	db "m"
	db "u"
	db 11h ;EXT:F (HOME)
	db "3"      ;Spalte 1
	db "d"
	db "c"
	db "e"
	db "+" ;EXT
	db "5"      ;Spalte 2
	db "g"
	db "b"
	db "t"
	db 2ah ;EXT:;
	db "1"      ;Spalte 3
	db "a"
	db "y"
	db "q"
	db "." ;EXT
	db "6"      ;Spalte 4
	db "h"
	db "n"
	db "z"
	db "?" ;EXT
	db "2"      ;Spalte 5
	db "s"
	db "x"
	db "w"
	db "/" ;EXT
	db "4"      ;Spalte 6
	db "f"
	db "v"
	db "r"
	db "-" ;EXT
	db "9"      ;Spalte 7+
	db "3"
	db 0dh ;Ret
	db "6"
	db 11h ;(home)
	db "7"      ;Spalte 8+
	db "1"
	db "0"
	db "4"
	db 18h ;(down)
	db 7fh ;DEL ;Spalte 9
	db 0dh ;Ret
	db 00h ;S.L.
	db 09h ;TAB
	db 13h ;EXT:C (LEFT/left)
	db "+"      ;Spalte A
	db "#"
	db 1bh ;ESC
	db "<"
	db 04h ;(right)
	db "~"      ;Spalte B
	db "{"
	db " "
	db "}"
	db 00h ;n.c.
	db "0"      ;Spalte C
	db "|"
	db "-"
	db "p"
	db 18h ;EXT:B (DOWN)
	db "9"      ;Spalte D
	db "l"
	db "."
	db "o"
	db 04h ;EXT:A (RIGHT)
	db "8"      ;Spalte E
	db "k"
	db ","
	db "i"
	db 05h ;EXT:E (UP)
	db "8"      ;Spalte F+
	db "2"
	db "."
	db "5"
	db 05h ;(up)
;
;
;;;
;
;      Shift Codes
;
;;;
;
	db "/"      ;Spalte 0
	db "J"
	db "M"
	db "U"
	db 11h ;EXT:F (HOME)
	db "@"      ;Spalte 1
	db "D"
	db "C"
	db "E"
	db "+" ;EXT
	db "%"      ;Spalte 2
	db "G"
	db "B"
	db "T"
	db 2ah ;EXT:;
	db "!"      ;Spalte 3
	db "A"
	db "Y"
	db "Q"
	db "." ;EXT
	db "&"      ;Spalte 4
	db "H"
	db "N"
	db "Z"
	db "?" ;EXT
	db 22h ; "   Spalte 5
	db "S"
	db "X"
	db "W"
	db "/" ;EXT
	db "$"      ;Spalte 6
	db "F"
	db "V"
	db "R"
	db "-" ;EXT
	db "9"      ;Spalte 7+
	db "3"
	db 0dh ;Ret
	db "6"
	db 11h ;(HOME)
	db "7"      ;Spalte 8+
	db "1"
	db "0"
	db "4"
	db 18h ;(DOWN)
	db 08h ;DEL ;Spalte 9
	db 0dh ;Ret
	db 00h ;S.L.
	db 09h ;TAB
	db 13h ;EXT:C (LEFT/left)
	db 2ah ;    Spalte A
	db "^"
	db 1bh ;ESC
	db ">"
	db 04h ;(right)
	db "?"      ;Spalte B
	db "["
	db " "
	db "]"
	db 00h ;n.c.
	db "="      ;Spalte C
	db "\"
	db "_"
	db "P"
	db 18h ;EXT:B (DOWN)
	db ")"      ;Spalte D
	db "L"
	db ":"
	db "O"
	db 04h ;EXT:A (RIGHT)
	db "("      ;Spalte E
	db "K"
	db ";"
	db "I"
	db 05h ;EXT:E (UP)
	db "8"      ;Spalte F+
	db "2"
	db 2ah
	db "5"
	db 05h ;(up)
;
;
;;;
;
;      Control Codes
;
;;;
;
	db 00h ;7; I/O #7     Spalte 0
	db 0ah ;J; LF
	db 0dh ;M; Ret
	db 15h ;U; NAK
	db 11h ;EXT:F (HOME)
	db 00h ;3; I/O #3     Spalte 1
	db 04h ;D; EOT
	db 03h ;C; ETX
	db 05h ;E; ENQ
	db "+" ;EXT
	db 00h ;5; I/O #5     Spalte 2
	db 07h ;G; Bell
	db 02h ;B; STX
	db 14h ;T; DC4
	db 2ah ;EXT:;
	db 00h ;1; I/O #1     Spalte 3
	db 01h ;A; SOH
	db 19h ;Y; EM
	db 11h ;Q; DC1
	db "." ;EXT
	db 00h ;6; I/O #6     Spalte 4
	db 08h ;H; BS
	db 0eh ;N; SO
	db 1Ah ;Z; SUB
	db "?" ;EXT
	db 00h ;2; I/O #2     Spalte 5
	db 13h ;S; DC3
	db 18h ;X; CAN
	db 17h ;W; ETB
	db "/" ;EXT
	db 00h ;4; I/OG #4    Spalte 6
	db 06h ;F; ACK
	db 16h ;V; SYN
	db 12h ;R; DC2
	db "-" ;EXT
	db 00h ;9; (NUL)      Spalte 7+
	db 00h ;3; (NUL)
	db 0dh ;Ret
	db 00h ;6; (NUL)
	db 11h ;(home)
	db 00h ;7; (NUL)      Spalte 8+
	db 00h ;1; (NUL)
	db 00h ;0; (NUL)
	db 00h ;4; (NUL)
	db 18h ;(down)
	db 1bh ;DEL; ESC      Spalte 9
	db 0dh ;Ret
	db 00h ;S.L.
	db 03h ;TAB; ETX (ESC)
	db 13h ;EXT:C (LEFT/left)
	db 00h ;+; (NUL)      Spalte A
	db 00h ;#; (NUL)
	db 1bh ;ESC
	db 00h ;>; (NUL)
	db 04h ;(right)
	db 1Fh ;~; US         Spalte B
	db 00h ;[; (NUL)
	db 00h ;Blank; (NUL)
	db 1Eh ;]; RS
	db 00h ;n.c.
	db 00h ;0; (NUL)      Spalte C
	db 1Dh ;\; GS
	db 60h ;-; ASCII `
	db 10h ;P; DLE
	db 18h ;EXT:B (DOWN)
	db 00h ;9; (NUL)      Spalte D
	db 0ch ;L; FF
	db 1ch ;.; FS
	db 0fh ;O; SI
	db 04h ;EXT:A (RIGHT)
	db 00h ;8; (NUL)      Spalte E
	db 0bh ;K; VT
	db 27h ;,; ASCII '
	db 09h ;I; HT
	db 05h ;EXT:E (UP)
	db 00h ;8; (NUL)      Spalte F+
	db 00h ;2; (NUL)
	db 00h ;.; (NUL)
	db 00h ;5; (NUL)
	db 05h ;(up)
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      Control-Codes in aufsteigender Reihenfolge
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      00h: CTL+Space NUL  Null
;      01h: CTL+A     SOH  Start of Heading
;      02h: CTL+B     STX  Start of Text
;      03h: CTL+C     ETX  End of Text
;           CTL+TAB  (Escape-Ersatz)
;      04h: CTL+D     EOT  End of Transmission
;      05h: CTL+E     ENQ  Enquiry
;      06h: CTL+F     ACK  Acknowledge
;      07h: CTL+G     BEL  Bell
;      08h: CTL+H     BS   Backspace
;      09h: CTL+I     HT   Horizontal Tabulation
;      0Ah: CTL+J     LF   Line feed
;      0Bh: CTL+K     VT   Vertical Tabulation
;      0Ch: CTL+L     FF   Form feed
;      0Dh: CTL+M     CR   Carriage Return
;      0Eh: CTL+N     SO   Shift out
;      0Fh: C7L+O     SI   Shift in
;      10h: CTL+P     DLE  Data Link Escape
;      11h: CTL+Q     DC1  Device Control 1
;      12h: CTL+R     DC2  Device Control 2
;      13h: CTL+S     DC3  Device Control 3
;      14h: CTL+T     DC4  Device Control 4
;      15h: CTL+U     NAK  Negative Acknowledge
;      16h: CTL+V     SYN  Synchronous idle
;      17h: CTL+W     ETB  End of transm. Block
;      18h: CTL+X     CAN  Cancel
;      19h: CTL+Y     EM   End of Medium
;      1Ah: CTL+Z     SUB  Substitute Character
;      1Bh: ESC       ESC  Escape
;           CTL+DEL  (Escape-Ersatz)
;      1Ch: CTL+ .    FS   File Separator
;      1Dh: CTL+\     GS   Group Separator
;      1Eh: CTL+]     RS   Record Separator
;      1Fh: CTL+~     US   Unit Separator
;
;      27h: CTL+ ,     '   ASCII
;      60h: CTL+ -     `   ASCII
;      7fh: SFT+DEL   DEL  Delete
;
;
;##################################################
;
; Belegung Systemram
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
;      RAM-Buffer
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
org    monram
;
codtab:	ds	200h ;FCT-Codes
batchb:	ds	100h ;Batch-Buffer
thermo:	ds	 20h ;Thermo-Prt.
fctbuf:	ds	 20h ;FCT-Verarb.
escbuf:	ds	  1h ;f.ESC-Sequenzen
escod: 	ds	  1h
escbf0:	ds	  1h
escbf1:	ds	  1h
;
bcup:  	ds	  2h ;Zeile 5
hlup:  	ds	  2h ;Zeile 6
vidend:	ds	  2h ;hinter Bildfenster
lininv:	ds	  2h ;neg.Zeilenl{nge
linlen:	ds	  2h ;Zeichen p.Zeile
hordsp:	ds	  1h ;Zeichen p.Zeile
verdsp:	ds	  1h ;Zeilen p.Seite
lin2:  	ds	  2h ;Zeile 2
liny:  	ds	  2h ;vorletzte Zeile
linz:  	ds	  2h ;letzte Zeile
update:	ds	  2h ;Cursor-Pos.
;
fctpoi:	ds	  2h
fctcnt:	ds	  1h
levflg:	ds	  1h
inpflg:	ds	  1h
updbuf:	ds	  2h
hlbuf: 	ds	  2h
dowo1: 	ds	  2h
dowo2: 	ds	  2h
hexadr:	ds	  2h ;LIST/REVISE
hexend:	ds	  2h
;
linbuf:	ds	 50h ;MEM/STP/DF]
;
		ds	 47h ;Monitor-Stack
stack: 	ds	  0h
;
		ds	 64h ;Branch-Bereich (Ass/Edi)
;
		ds	 28h ;User-Stack
usrstk:	ds	  0h
;
intbuf:	ds	 0ch ;Interrupt-Buffer
int55: 	ds	  6h
int65: 	ds	  6h
int75: 	ds	  3h
;
rega:  	ds	  1h
regb:  	ds	  2h
regd:  	ds	  2h
regf:  	ds	  1h
regh:  	ds	  2h
regs:  	ds	  3h
dspbuf:	ds	  8h ;SSG-Buffer
;
data:  	ds	1h
adres: 	ds	1h
adrhi: 	ds	1h
modflg:	ds	1h
fctbf: 	ds	1h
srcbeg:	ds	2h
srcend:	ds	2h
dstbeg:	ds	2h
dstend:	ds	2h
regnr: 	ds	1h
ioflag:	ds	1h
invers:	ds	1h
maxbuf:	ds	1h
keybyt:	ds	1h
		ds	1h
hibuf: 	ds	2h
hbuf:  	ds	1h
hibuf2:	ds	1h
hbuf2: 	ds	2h
brkpt1:	ds	2h
opcod1:	ds	1h
brkpt2:	ds	2h
opcod2:	ds	2h
;
second:	ds	2h
uhrbuf:	ds	0eh
ascbuf:	ds	16h
;
;
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
org    linbuf
;
ctsflg: ds   1h ;CTS (DF] Senden)
txmflg: ds   1h ;XON/XOF
ramotf: ds   1h ;RAM-Output
txmpoi: ds   2h ;RAM-Out-Pointer
erotfl: ds   1h ;Out-Err.
dsrflg: ds   1h ;DSR (DF] Empfangen)
recflg: ds   1h ;XON/XOF
raminf: ds   1h ;RAM-Input
recpoi: ds   2h ;RAM-In-Pointer
erinfl: ds   1h ;Inp-Err.
keylok: ds   1h ;Key-Freigabe
queofs: ds   1h ;Queue-Offset
;
queue:  ds 28h ;DF]/MEM-Zeilenbuffer 40d
;
linbeg: ds  2h ;Zeilenanfang Bildschirm (MEM/STP))
dsplcm: ds  2h ;Versatz (HI=00h)
limin:  ds  1h ;linker Rand
limax:  ds  1h ;rechter Rand
memflg: ds  1h ;'s'/'r'
;
;
end
;